// Generated by CoffeeScript 1.10.0
(function() {
  var $overlay, baseUrl, checkAndRedirect, getLanguageLinks, hideOverlay, injectStyle, mayBeBot, overlayStyle, referrerHasSameHost, removeEl, showOverlay, showSpinner, spinnerStyle;

  $overlay = null;

  overlayStyle = null;

  spinnerStyle = null;

  baseUrl = function(href) {
    var baseurl, p;
    p = href.indexOf('//');
    p = href.indexOf('/', p + 2);
    return baseurl = href.substr(0, p + 1);
  };

  referrerHasSameHost = function() {
    var base;
    if (document.referrer) {
      base = baseUrl(document.referrer);
      return window.location.href.substr(0, base.length) === base;
    }
    return false;
  };

  getLanguageLinks = function() {
    var e, i, len, links, ref;
    links = {};
    ref = document.querySelectorAll('link[rel="alternate"][hreflang]');
    for (i = 0, len = ref.length; i < len; i++) {
      e = ref[i];
      links[e.getAttribute('hreflang')] = e.getAttribute('href');
    }
    return links;
  };

  mayBeBot = function() {
    var agent, engine, i, iagent, j, len, len1, ref, ref1, search;
    agent = navigator.userAgent;
    if (!agent) {
      return true;
    }
    if (agent.indexOf('Mozilla') !== -1) {
      iagent = agent.toLowerCase();
      ref = ['bot', 'crawler', 'spider'];
      for (i = 0, len = ref.length; i < len; i++) {
        search = ref[i];
        if (iagent.indexOf(search) !== -1) {
          return true;
        }
      }
      return false;
    }
    ref1 = ['Webkit', 'Safari', 'Opera', 'Dillo', 'Lynx', 'Links', 'w3m', 'Midori', 'iCab'];
    for (j = 0, len1 = ref1.length; j < len1; j++) {
      engine = ref1[j];
      if (agent.indexOf(engine) !== -1) {
        return false;
      }
    }
    return true;
  };

  showOverlay = function() {
    overlayStyle = injectStyle('body {visibility: hidden;}');
    window.onerror = function() {
      removeEl(overlayStyle);
      hideOverlay();
    };
    $overlay = jQuery('<div id="geoip-language-redirect-overlay"></div>');
    jQuery(function() {
      if ($overlay) {
        $overlay.css({
          'position': 'fixed',
          'top': 0,
          'right': 0,
          'bottom': 0,
          'left': 0,
          'z-index': 1000,
          'background': '#fff'
        }).appendTo(document.body);
        setTimeout(function() {
          showSpinner();
        }, 1000);
      }
      removeEl(overlayStyle);
    });
  };

  showSpinner = function() {
    if ($overlay) {
      $overlay.append('<div class="spinner"><div class="bounce1"></div><div class="bounce2"></div><div class="bounce3"></div></div>');
      spinnerStyle = injectStyle('.spinner{margin:50vh auto 0;width:100px;text-align:center}.spinner > div{width:18px;height:18px;margin-right:10px;background-color:#333;border-radius:100%;display:inline-block;-webkit-animation:sk-bouncedelay 1.4s infinite ease-in-out both;animation:sk-bouncedelay 1.4s infinite ease-in-out both}.spinner .bounce1{-webkit-animation-delay:-.32s;animation-delay:-.32s}.spinner .bounce2{-webkit-animation-delay:-.16s;animation-delay:-.16s}@-webkit-keyframes sk-bouncedelay{0%,80%,100%{-webkit-transform:scale(0)}40%{-webkit-transform:scale(1.0)}}@keyframes sk-bouncedelay{0%,80%,100%{-webkit-transform:scale(0);transform:scale(0)}40%{-webkit-transform:scale(1.0);transform:scale(1.0)}}');
    }
  };

  hideOverlay = function() {
    $overlay && $overlay.remove();
    $overlay = null;
    removeEl(overlayStyle);
    removeEl(spinnerStyle);
  };

  injectStyle = function(css) {
    var head, style;
    head = document.head || document.getElementsByTagName('head')[0];
    style = document.createElement('style');
    style.type = 'text/css';
    if (style.styleSheet) {
      style.styleSheet.cssText = css;
    } else {
      style.appendChild(document.createTextNode(css));
    }
    head.appendChild(style);
    return style;
  };

  removeEl = function(el) {
    el && el.parentNode && el.parentNode.removeChild(el);
    el = null;
  };

  checkAndRedirect = function() {
    var current, links;
    if (referrerHasSameHost() || mayBeBot()) {
      return;
    }
    showOverlay();
    links = getLanguageLinks();
    current = document.getElementsByTagName('html')[0].getAttribute('lang');
    jQuery.getJSON('/geoip-language-suggestions').done(function(data) {
      var i, lang, len;
      for (i = 0, len = data.length; i < len; i++) {
        lang = data[i];
        if (lang === current) {
          hideOverlay();
          return;
        }
        if (links.hasOwnProperty(lang)) {
          window.location = links[lang];
          return;
        }
      }
      hideOverlay();
    }).fail(function() {
      hideOverlay();
    });
  };

  checkAndRedirect();

}).call(this);
